abuild.in 26.3 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
74 75

	
Linux User's avatar
Linux User committed
76 77
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
97
	local i
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
111 112 113 114 115 116 117
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

118 119
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
120 121 122 123
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
124
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
125 126 127
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
128 129
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
130

131 132
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
133
			source_has $i || die "$i exists in md5sums but is missing in source"
134 135
		done
	fi
136

137 138 139
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
140 141

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
142 143

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
144 145 146 147
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
148
	local dummy f
149 150 151
	if [ -z "$source" ]; then
		return 0
	fi
152
	if [ -z "$md5sums" ]; then
153
		die "Use 'abuild checksum' to generate/update the checksum(s)"
154
	fi
155 156 157
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
158
	fetch || return 1
159
	msg "Checking md5sums..."
160
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
161 162 163 164
}

uri_fetch() {
	local uri="$1"
165
	local d="${uri##*/}"	# $(basename $uri)
166 167 168 169
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
170 171 172 173 174
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
175
	mkdir -p "$SRCDEST"
176 177 178
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
179
	fi
Linux User's avatar
Linux User committed
180
	msg "Fetching $uri"
181 182
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
183 184
}

185 186
is_remote() {
	case "$1" in
Natanael Copa's avatar
Natanael Copa committed
187
		http://*|ftp://*|https://*)
188 189 190 191 192
			return 0;;
	esac
	return 1
}

193 194 195 196 197 198 199 200 201 202
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
		uri_fetch "$DISTFILES_MIRROR"/$d && return 0
	fi
	uri_fetch "$uri"
}

203
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
204 205
	local s
	mkdir -p "$srcdir"
206 207
	for s in $source; do
		if is_remote "$s"; then
208
			uri_fetch_mirror "$s" || return 1
209 210 211 212
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
213 214 215
	done
}

216 217 218 219
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
220
# unpack the sources
221
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
222
	local u
223
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
224 225 226 227
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
228
			*.tar.gz|*.tgz)
229
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
230 231
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
232
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
233
				tar -C "$srcdir" -jxf "$s" || return 1;;
234 235 236 237
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
238 239 240
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
241 242 243 244
		esac
	done
}

245 246 247 248
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
249 250
# cleanup source and package dir
clean() {
251
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
252
	rm -rf "$srcdir"
253
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
254 255 256 257 258 259
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
260 261 262 263
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
264 265 266 267 268
	done
}

cleanpkg() {
	local i
269
	getpkgver || return 1
270
	msg "Cleaning built packages..."
271
	for i in $pkgname $subpackages; do
272 273
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
274
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
275
	done
276
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
277 278
}

279 280 281
# clean all packages except current
cleanoldpkg() {
	local i j
282
	getpkgver || return 1
283 284 285 286 287 288 289 290 291
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
310 311
runpart() {
	local part=$1
312
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
313 314 315 316
	$part || die "$part failed"
}

# override those in your build script
317 318 319 320 321 322 323 324
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
325 326 327 328
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
329
build() {
330
	:
Natanael Copa's avatar
Natanael Copa committed
331 332
}

333 334 335 336 337 338
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
339 340 341 342 343 344 345 346 347
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

348
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
349
	if [ -z "$subpackages" ]; then
350 351
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
352 353
	local i
	cd "$startdir"
354
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
355 356
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
357
		msg "Running split function $func..."
358
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
359
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
360 361 362
	done
}

363
prepare_metafiles() {
364
	getpkgver || return 1
365 366
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
367
	local dir=${subpkgdir:-$pkgdir}
368
	local pkg="$name-$pkgver-r$pkgrel.apk"
369
	local pkginfo="$controldir"/.PKGINFO
370
	local sub
Natanael Copa's avatar
Natanael Copa committed
371 372 373
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
374
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
375 376 377
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

378
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
379
	if [ -n "$FAKEROOTKEY" ]; then
380
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
381
	fi
382 383
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
384
pkgname = $name
385
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
386 387 388 389 390 391
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
392 393
	local i deps
	deps="$depends"
394
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
395 396
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
397 398 399 400 401
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
402 403
	fi
	
Natanael Copa's avatar
Natanael Copa committed
404
	for i in $license; do
405
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
406 407
	done
	for i in $replaces; do
408
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
409
	done
410
	for i in $deps; do
411
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
412 413
	done
	for i in $conflicts; do
414
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
415 416
	done
	for i in $provides; do
417
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
418 419
	done
	for i in $backup; do
420
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
421
	done
Natanael Copa's avatar
Natanael Copa committed
422 423 424
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
425 426

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
427
	for i in $install ${triggers%%:*}; do
428 429
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
430
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
431 432
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
433
			*) 	error "$script: Invalid install/trigger script"
434 435 436
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
437
		cp "$startdir/$i" "$controldir/$script" || return 1
438
		chmod +x "$controldir/$script"
439 440
		metafiles="$metafiles $script"
	done
441
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
442
}
443

444 445 446
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
447 448
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
449
	scanelf -Rn "$dir" | awk -F "\ " '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
450 451 452
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
453 454
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
455
	done
Natanael Copa's avatar
Natanael Copa committed
456 457
}

458
prepare_package() {
459
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
460
	stripbin
461
	prepare_metafiles && prepare_tracedeps
462 463 464 465 466 467 468 469
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

470 471 472
trace_apk_deps() {
	local name="$1"
	local dir="$2"
473 474
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
475 476 477 478 479 480
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
		msg "Added pkgconfig as dependency"
		echo "depend = pkgconfig" >> "$dir"/.PKGINFO
	fi
481
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
482
		found=
483
		# first check if its provide by same apkbuild
484
		for j in "$dir"/../.control.*/.provides-so; do
485
			grep -w "$i" "$j" >/dev/null || continue
486
			found=${j%/.provides-so}
487
			found=${found##*/.control.}
488
			break
489 490 491
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
492
			found=$($APK info -q -W /lib/$i /usr/lib/$i)
493 494 495 496 497
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
498
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
499 500 501
			warning "You can remove '$found' from depends"
			continue
		fi
502 503
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
504 505 506 507 508 509 510 511
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

512 513
create_apks() {
	local file
514
	getpkgver || return 1
515
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
516 517 518
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
519
		local apk=$name-$ver.apk
520
		local datadir="$pkgbasedir"/$name
521 522

		trace_apk_deps "$name" "$dir" || return 1
523
		msg "Creating $apk..."
524
		(
525 526
		cd "$datadir"
		# data.tar.gz
527 528 529 530 531 532
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
533 534 535 536 537 538

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
539
		cd "$dir"
540 541
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
542
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
543

544 545 546
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
547 548 549
	done
}

550
update_abuildrepo() {
551
	if ! apk_up2date || [ -n "$force" ]; then
552
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
553
			&& prepare && mkusers && rootpkg || return 1
554
	fi
555

556
	local apk
557 558
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
559 560 561 562 563 564 565 566 567

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
568
	for apk in $(listpkg); do
569
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
570 571
	done

572
	msg "Updating the cached abuild repository index..."
573 574 575 576 577
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
578
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
579 580
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
581 582 583
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
584
	chmod 644 APKINDEX.tar.gz
585 586
}

587
# predefined splitfunc doc
588
default_doc() {
589
	depends="$depends_doc"
590
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
591
	triggers="$triggers_doc"
Natanael Copa's avatar
Natanael Copa committed
592
	local i
593
	for i in doc man info html sgml licenses gtk-doc; do
594 595 596
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
597 598
		fi
	done
599 600 601
	
	rm -f "$subpkgdir/usr/share/info/dir"

602 603 604
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
605 606 607 608

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
609
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
610 611 612
	return 0
}

613 614 615 616
doc() {
	default_doc
}

617
# predefined splitfunc mod
618
default_mod() {
619
	depends="$kernel $depends_mod"
620
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
621
	for i in firmware modules; do
622 623 624
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
625
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
626 627 628 629
		fi
	done
}

630 631 632 633
mod() {
	default_mod
}

634
# predefined splitfunc dev
635
default_dev() {
636
	local i
637
	depends="$pkgname $depends_dev"
638
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
639
	triggers="$triggers_dev"
640 641 642 643
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
644
	cd "$pkgdir" || return 0
645 646 647 648 649
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
650 651
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
652
			mkdir -p "$d"
653
			mv "$pkgdir/$i" "$d"
654
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
655 656
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
657
	return 0
Natanael Copa's avatar
Natanael Copa committed
658 659
}

660 661 662 663
dev() {
	default_dev
}

664 665 666 667
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
668 669
# build and package in fakeroot
rootpkg() {
670 671 672 673
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
674
		do_build=package
675
	fi
Natanael Copa's avatar
Natanael Copa committed
676
	cd "$startdir"
677
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
678
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
679 680
		prepare_subpackages \
		prepare_package \
681
		create_apks
Natanael Copa's avatar
Natanael Copa committed
682 683 684
}

srcpkg() {
685
	getpkgver || return 1
686
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
687
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
688 689 690 691 692
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
693
	msg "Creating source package $p.src.tar.gz..."
694
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
695 696
}

697
# check if package is up to date
698
apk_up2date() {
699
	getpkgver || return 1
700
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
701
	local i s
Natanael Copa's avatar
Natanael Copa committed
702
	cd "$startdir"
703 704 705 706 707
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

708
	for i in $source APKBUILD; do
709 710 711 712 713 714
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
715 716 717 718 719 720 721
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

722
abuildindex_up2date() {
723
	local i apk
724
	getpkgver || return 1
725 726
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
727
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
728 729 730 731 732
	done
	return 0
}

up2date() {
733 734 735 736 737 738 739
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
740 741
}

742 743 744 745 746 747 748
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
749 750
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
751 752 753 754
		pkgname=
		subpackages=
		depends=
		makedepends=
755
		. $i
756
		dir=${i%/APKBUILD}
757
		deps=
758
		# filter out conflicts from deps and version info
759 760 761 762
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
763
			deps="$deps ${j%%[<>=]*}"
764
		done
765
		for j in $pkgname $subpackages; do
766
			echo "o ${j%%:*} $dir"
767
			set -- $deps
768 769 770 771 772 773 774
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
775 776
		done
	done
777
	)
778 779
}

780
deptrace() {
781 782 783
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
784
		deps="$deps ${i%%[<>=]*}"
785
	done
786
	[ -z "$deps" ] && return 0
787 788 789
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
790
			$APK info -q | sort |  sed 's/^/i /'
791
		fi
792
	) | awk -v pkgs="$deps" '
793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
818
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
819
	local filtered_deps= conflicts=
820
	[ -n "$nodeps" ] && return 0
821
	msg "Analyzing dependencies..."
822

823 824 825
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
826
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
827 828
	done

829
	installed_deps=$($APK info -e $deps)
830
	# find which deps are missing
831
	for i in $deps; do
832
		if [ "${i#\!}" != "$i" ]; then
833
			list_has ${i#\!} $installed_deps \
834
				&& conflicts="$conflicts ${i#\!}"
835
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
836 837 838 839
			missing="$missing $i"
		fi
	done

840 841 842 843 844 845 846 847 848 849
	if [ -n "$conflicts" ]; then
		die "Conflicting package(s) installed:$conflics"
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
850

851
	uninstall_after=".makedepends-$pkgname $uninstall_after"
852
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
853 854
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
855
		$SUDO $APK add --repository "$abuildrepo" \
856 857
			--wait 30 \
			--simulate --quiet $deps || return 1
858
		$SUDO $APK add --repository "$abuildrepo" \
859
			--wait 30 \
860 861
			--virtual .makedepends-$pkgname $deps \
			&& return 0
862
	fi
863 864
	
	[ -z "$recursive" ] && return 1
865 866 867

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
868
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
869
		if [ -z "$m" ]; then
870 871 872
			missing="$missing $i"
		fi
	done
873 874
	
	for i in $(deptrace $missing); do
875 876 877
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
878 879 880 881 882 883 884 885 886 887

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
888
			$recursive $upgrade $color_opt abuildindex || return 1
889
	done
890
	$SUDO $APK add -u --repository "$abuildrepo" \
891
		--wait 30 \
892
		--virtual .makedepends-$pkgname $deps
893 894
}

895
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
896 897
checksum() {
	local s files
898
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
899
	fetch
900
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
901 902 903 904
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
905 906
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
907 908
}

909
stripbin() {
910
	local bin
911
	options_has "!strip" && return 0
912 913
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
914 915 916
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
917 918
}

919 920 921
# simply list target apks
listpkg() {
	local i 
922
	getpkgver || return 1
923 924 925 926 927
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
928 929 930 931 932 933 934 935
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
936 937 938 939 940 941 942 943
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

944 945 946 947 948 949 950 951 952 953 954
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

955 956 957 958 959 960
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
961
		i=${i%%[<>=]*}
962 963 964 965 966 967
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

968 969 970 971
options_has() {
	list_has "$1" $options
}

972
depends_has() {
973
	deplist_has "$1" $depends
974 975
}

Natanael Copa's avatar
Natanael Copa committed
976
makedepends_has() {
977
	deplist_has "$1" $makedepends
Natanael Copa's avatar
Natanael Copa committed
978 979
}

Natanael Copa's avatar
Natanael Copa committed
980 981 982 983
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
984 985 986 987
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
988 989
# install package after build
post_add() {
990
	getpkgver || return 1
Natanael Copa's avatar
abuild:  
Natanael Copa committed
991 992 993 994 995 996
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
997
	deps=$($APK index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
Natanael Copa's avatar
abuild:  
Natanael Copa committed
998 999 1000 1001 1002
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
1003
	$SUDO $APK add --wait 30 -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1004 1005
}

1006
installdeps() {
1007
	local deps i
1008
	sudo $APK add --wait 30 --repository "$abuildrepo" \
1009
		--virtual .makedepends-$pkgname \
1010
		$makedepends
1011 1012 1013
}

uninstalldeps (){
1014
	sudo $APK del .makedepends-$pkgname
1015
}
1016 1017 1018 1019 1020

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
1021
		update_abuildrepo
1022 1023 1024
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1025
usage() {
1026 1027
	echo "$program $abuild_ver"
	echo "usage: $program [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
1028
	echo "              [-s SRCDEST] [cmd] ..."
1029
	echo "       $program [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
1030
	echo "Options:"
1031
	echo " -c  Enable colored output"
1032
	echo " -d  Disable dependency checking"
Natanael Copa's avatar
Natanael Copa committed
1033
	echo " -f  Force specified cmd, even if they are already done"
1034
	echo " -F  Force run as root"
1035 1036
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
1037
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
1038
	echo " -m  Disable colors (monochrome)"
1039
	echo " -p  Set package destination directory"
1040
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
1041
	echo " -q  Quiet"
1042 1043
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
1044
	echo " -s  Set source package destination directory"
1045
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
1046 1047
	echo ""
	echo "Commands:"
1048
	echo "  checksum    Generate checksum to be included in APKBUILD"
1049 1050 1051 1052 1053
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
1054
	echo "  listpkg     List target packages"
1055 1056 1057
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
1058
	echo "  cleanoldpkg Remove binary packages except current version"
1059 1060 1061 1062
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
1063 1064
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
1065 1066 1067 1068 1069
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
1070 1071
unset force
unset recursive
1072
while getopts "cdfFhi:kimnp:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
1073
	case $opt in
1074 1075
		'c') default_colors
		     color_opt="-c";;
1076
		'd') nodeps=1;;
1077 1078
		'f') force="-f";;
		'F') forceroot="-F";;
1079 1080
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
1081
		'k') keep="-k";;
1082 1083
		'm') monochrome
		     color_opt="-m";;